require("stats")
require("cluster")

if (!isGeneric("predict"))
  setGeneric("predict", function(object, ...) standardGeneric("predict"))
if (!isGeneric("pltree"))
  setGeneric("pltree", function(x, ...) standardGeneric("pltree"))

if (!isGeneric("screeplot"))
  setGeneric("screeplot", function(x, npcs=NULL,
                                   type=FALSE, main='', ...)
             standardGeneric("screeplot"))


redscale <- function(N) {
  rgb((1:N)-1, 0, 0, maxColorValue=N)
}

greenscale <- function(N) {
  rgb(0, (1:N)-1, 0, maxColorValue=N)
}

bluescale <- function(N) {
  rgb(0, 0, (1:N)-1, maxColorValue=N)
}

blueyellow <- function(N) {
  x <- (1:N)-1
  rgb(x, x, rev(x), maxColorValue=N)
}

redgreen <- function(N) {
  M <- floor((N+1)/2)
  r <- c(rep(0, M), 0:M)
  g <- -c(-M:0, rep(0, M))
  rgb(r,g, rep(0, 2*M+1), maxColorValue=M)
}

jetColors <- function(N){

  ## JET.COLORS(N)
  ## Defines a MATLAB jet colormap (blue is low, red is high)
  ## with N levels. Returns an N by 3 matrix of rgb values.  
  
  k <- ceiling(N/4);
  temp.red <- c(rep(0,2*k), 1:k, rep(k,k-1), k:1);
  temp.green <- c(rep(0,k), 1:k, rep(k,k-1), k:1, rep(0,k));
  temp.blue <- c(1:k, rep(k,k-1), k:1, rep(0,2*k));
  temp.rgb <- cbind(temp.red, temp.green, temp.blue);
  delta <- 5*k-1 - N;
  delta <- ceiling(delta/2);
  temp.rgb <- temp.rgb[delta:(delta+N-1),]/k;

  ## assemble everything; last value is returned
  rgb(temp.rgb[,1], temp.rgb[,2], temp.rgb[,3]);

}
